From: Adrian Hunter <adrian.hunter@intel.com>
To: Arnaldo Carvalho de Melo <acme@kernel.org>
Cc: Jiri Olsa <jolsa@redhat.com>, Ian Rogers <irogers@google.com>,
Alexey Bayduraev <alexey.v.bayduraev@linux.intel.com>,
Namhyung Kim <namhyung@kernel.org>, Leo Yan <leo.yan@linaro.org>,
linux-kernel@vger.kernel.org
Subject: [PATCH V4 01/15] perf intel-pt: Add a test for system-wide side band
Date: Tue, 24 May 2022 10:54:22 +0300 [thread overview]
Message-ID: <20220524075436.29144-2-adrian.hunter@intel.com> (raw)
In-Reply-To: <20220524075436.29144-1-adrian.hunter@intel.com>
Add a test for system-wide side band even when tracing selected CPUs.
The test fails before the patches up to "perf tools: Allow system-wide
events to keep their own CPUs" are applied, passes afterwards.
Tested-by: Ian Rogers <irogers@google.com>
Acked-by: Namhyung Kim <namhyung@kernel.org>
Signed-off-by: Adrian Hunter <adrian.hunter@intel.com>
---
tools/perf/tests/shell/test_intel_pt.sh | 71 +++++++++++++++++++++++++
1 file changed, 71 insertions(+)
create mode 100755 tools/perf/tests/shell/test_intel_pt.sh
diff --git a/tools/perf/tests/shell/test_intel_pt.sh b/tools/perf/tests/shell/test_intel_pt.sh
new file mode 100755
index 000000000000..a3298643884d
--- /dev/null
+++ b/tools/perf/tests/shell/test_intel_pt.sh
@@ -0,0 +1,71 @@
+#!/bin/sh
+# Miscellaneous Intel PT testing
+# SPDX-License-Identifier: GPL-2.0
+
+set -e
+
+# Skip if no Intel PT
+perf list | grep -q 'intel_pt//' || exit 2
+
+skip_cnt=0
+ok_cnt=0
+err_cnt=0
+
+tmpfile=`mktemp`
+perfdatafile=`mktemp`
+
+can_cpu_wide()
+{
+ perf record -o ${tmpfile} -B -N --no-bpf-event -e dummy:u -C $1 true 2>&1 >/dev/null || return 2
+ return 0
+}
+
+test_system_wide_side_band()
+{
+ # Need CPU 0 and CPU 1
+ can_cpu_wide 0 || return $?
+ can_cpu_wide 1 || return $?
+
+ # Record on CPU 0 a task running on CPU 1
+ perf record -B -N --no-bpf-event -o ${perfdatafile} -e intel_pt//u -C 0 -- taskset --cpu-list 1 uname
+
+ # Should get MMAP events from CPU 1 because they can be needed to decode
+ mmap_cnt=`perf script -i ${perfdatafile} --no-itrace --show-mmap-events -C 1 2>/dev/null | grep MMAP | wc -l`
+
+ if [ ${mmap_cnt} -gt 0 ] ; then
+ return 0
+ fi
+
+ echo "Failed to record MMAP events on CPU 1 when tracing CPU 0"
+ return 1
+}
+
+count_result()
+{
+ if [ $1 -eq 2 ] ; then
+ skip_cnt=`expr ${skip_cnt} \+ 1`
+ return
+ fi
+ if [ $1 -eq 0 ] ; then
+ ok_cnt=`expr ${ok_cnt} \+ 1`
+ return
+ fi
+ err_cnt=`expr ${err_cnt} \+ 1`
+}
+
+test_system_wide_side_band
+
+count_result $?
+
+rm -f ${tmpfile}
+rm -f ${perfdatafile}
+
+if [ ${err_cnt} -gt 0 ] ; then
+ exit 1
+fi
+
+if [ ${ok_cnt} -gt 0 ] ; then
+ exit 0
+fi
+
+exit 2
--
2.25.1
next prev parent reply other threads:[~2022-05-24 7:55 UTC|newest]
Thread overview: 18+ messages / expand[flat|nested] mbox.gz Atom feed top
2022-05-24 7:54 [PATCH V4 00/15] perf intel-pt: Better support for perf record --cpu Adrian Hunter
2022-05-24 7:54 ` Adrian Hunter [this message]
2022-05-24 7:54 ` [PATCH V4 02/15] perf auxtrace: Add mmap_needed to auxtrace_mmap_params Adrian Hunter
2022-05-24 7:54 ` [PATCH V4 03/15] perf auxtrace: Remove auxtrace_mmap_params__set_idx() per_cpu parameter Adrian Hunter
2022-05-24 7:54 ` [PATCH V4 04/15] perf evlist: Factor out evlist__dummy_event() Adrian Hunter
2022-05-24 7:54 ` [PATCH V4 05/15] perf evlist: Add evlist__add_dummy_on_all_cpus() Adrian Hunter
2022-05-24 7:54 ` [PATCH V4 06/15] perf record: Use evlist__add_dummy_on_all_cpus() in record__config_text_poke() Adrian Hunter
2022-05-24 7:54 ` [PATCH V4 07/15] perf intel-pt: Use evlist__add_dummy_on_all_cpus() for switch tracking Adrian Hunter
2022-05-24 7:54 ` [PATCH V4 08/15] perf intel-pt: Track sideband system-wide when needed Adrian Hunter
2022-05-24 7:54 ` [PATCH V4 09/15] perf tools: Allow all_cpus to be a superset of user_requested_cpus Adrian Hunter
2022-05-24 7:54 ` [PATCH V4 10/15] libperf evlist: Allow mixing per-thread and per-cpu mmaps Adrian Hunter
2022-05-24 7:54 ` [PATCH V4 11/15] libperf evlist: Check nr_mmaps is correct Adrian Hunter
2022-05-24 7:54 ` [PATCH V4 12/15] perf stat: Add requires_cpu flag for uncore Adrian Hunter
2022-05-24 7:54 ` [PATCH V4 13/15] libperf evsel: Add comments for booleans Adrian Hunter
2022-05-24 7:54 ` [PATCH V4 14/15] perf tools: Allow system-wide events to keep their own CPUs Adrian Hunter
2022-05-24 7:54 ` [PATCH V4 15/15] perf tools: Allow system-wide events to keep their own threads Adrian Hunter
2022-05-25 5:01 ` [PATCH V4 00/15] perf intel-pt: Better support for perf record --cpu Ian Rogers
2022-05-25 11:00 ` Arnaldo Carvalho de Melo
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20220524075436.29144-2-adrian.hunter@intel.com \
--to=adrian.hunter@intel.com \
--cc=acme@kernel.org \
--cc=alexey.v.bayduraev@linux.intel.com \
--cc=irogers@google.com \
--cc=jolsa@redhat.com \
--cc=leo.yan@linaro.org \
--cc=linux-kernel@vger.kernel.org \
--cc=namhyung@kernel.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox